<div class='cw-form' style='max-width: 1000px; margin: 20px auto'>
  <dx-form #cwForm [colCount]="4" [(formData)]="cwFormData" validationGroup='cwValidation'
    (onFieldDataChanged)='onFieldDataChanged($event)'>
    <dxi-item itemType='group' [colSpan]='4' [colCount]='4'>
      <dxi-item [label]="{text: 'SO Number'}" dataField='o_refNumber' editorType='dxTextBox' [editorOptions]="{placeholder: 'SO Number' }">
        <dxi-validation-rule type="required"></dxi-validation-rule>
      </dxi-item>
      <dxi-item [label]="{text: 'Trip No'}" dataField='t_refNumber' editorType='dxTextBox' [editorOptions]="{ placeholder: 'Ref Number'}">
        <dxi-validation-rule type="required"></dxi-validation-rule>
      </dxi-item>
      <dxi-item editorType='dxButton' [editorOptions]="{icon: 'edit', text: 'Move', onClick: moveOrder}"></dxi-item>
      <dxi-item editorType='dxButton'
        [editorOptions]="{icon: 'clear', text: 'Remove from Trip', onClick: removeOrderFromTrip }"></dxi-item>
    </dxi-item>

    <dxi-item itemType='group' [colSpan]='4' [colCount]='4'>
      <dxi-item [label]="{text: 'SO Number'}" dataField='soNumber' editorType='dxTextBox' [editorOptions]="{ placeholder: 'SO Number' }">
      </dxi-item>
      <dxi-item [label]="{text: 'Status'}" dataField='o_statusId' editorType='dxSelectBox'
        [editorOptions]="{dataSource: dsOrderStatusDesc, displayExpr: 'name', valueExpr: 'id'}">
      </dxi-item>
      <dxi-item editorType='dxButton' [editorOptions]="{icon: 'edit', text: 'Change status', onClick: changeStatus}">
      </dxi-item>
    </dxi-item>
    <dxi-item itemType='group' [colSpan]='4' [colCount]='4'>
      <dxi-item [label]="{text: 'Trip No'}" dataField='tripNo' editorType='dxTextBox' [editorOptions]="{ placeholder: 'Ref Number'}">
      </dxi-item>
      <dxi-item [label]="{text: 'Status'}" dataField='t_statusId' editorType='dxSelectBox'
        [editorOptions]="{ dataSource: dsTripStatusDesc, displayExpr: 'name', valueExpr: 'id'}">
      </dxi-item>
      <dxi-item editorType='dxButton' [editorOptions]="{icon: 'edit', text: 'Change status', onClick: changeStatus}">
      </dxi-item>
    </dxi-item>
  </dx-form>
  <hr>
  <div style='display: flex; margin: 20px;'>
    <dx-text-box style='display: inline-block;' [(value)]='cwFormData.valueToFind' width='200'
      placeholder='Trip/Order refNumber'></dx-text-box>
    <dx-check-box style='margin: 10px;' [(value)]='cwFormData.isTrip' text='Is Trip'></dx-check-box>
    <dx-button icon='search' text='Cauta' (onClick)='onSearchTrip($event)'></dx-button>
  </div>
  <dx-tab-panel>
    <dxi-item itemTemplate="orderTab" title="Order Line" [(visible)]='!cwFormData.isTrip'>
      <div *dxTemplate="let tab of 'orderTab'">
        <dx-scroll-view height='calc(100vh - 400px)'>
          <dx-form [formData]='cwFormData.orderDetails'></dx-form>
        </dx-scroll-view>
      </div>
    </dxi-item>
    <dxi-item itemTemplate="orderStatusTab" title="Status" [(visible)]='!cwFormData.isTrip'>
      <div *dxTemplate="let tab of 'orderStatusTab'">
        <dx-data-grid [dataSource]='dsOrderStatus'>
          <dxi-column caption='Type' dataField='type' dataType='number'>
            <dxo-lookup [dataSource]='dsTypes' valueExpr='id' displayExpr='name'></dxo-lookup>
          </dxi-column>
          <dxi-column caption='Rescheduled date' dataField='rescheduleDate' dataType='date'
            calculateSortValue='rescheduleDate' [calculateDisplayValue]='ds.getDate'></dxi-column>
          <dxi-column caption='User' dataField='userId' dataType='string'>
            <dxo-lookup [dataSource]='dsUser' valueExpr='id' displayExpr='loginName'></dxo-lookup>
          </dxi-column>
          <dxi-column caption='Status date' dataField='statusDate' dataType='datetime' calculateSortValue='statusDate'
            [calculateDisplayValue]='ds.getDateTime'></dxi-column>
          <dxi-column caption='Comments' dataField='comments' dataType='string'></dxi-column>
        </dx-data-grid>
      </div>
    </dxi-item>
    <dxi-item itemTemplate="tripTab" title="Trip">
      <div *dxTemplate="let tab of 'tripTab'">
        <dx-scroll-view height='calc(100vh - 400px)'>
          <dx-form [formData]='cwFormData.tripDetails'></dx-form>
        </dx-scroll-view>
      </div>
    </dxi-item>
    <dxi-item itemTemplate='orderGrid' title='Orders for trip'  [(visible)]='cwFormData.isTrip'>
      <dx-data-grid [dataSource]='dsOrdersTrip' [columnAutoWidth]='true' width='auto' height='calc(100vh - 400px)' [editing]='{ allowUpdating: true, allowDeleting: true}'>
        <dxi-column caption='SO Number' dataField='ol_refNumber' dataType='number' [allowHeaderFiltering]='false'
          [allowEditing]="false"></dxi-column>
        <dxi-column caption='Customer Code' dataField='c_code' dataType='string' [allowEditing]="false"></dxi-column>
        <dxi-column caption='Customer' dataField='c_name' dataType='string' [allowHeaderFiltering]='false'
          [allowEditing]="false"></dxi-column>
        <dxi-column caption='Ship to Party' dataField='ca_code' dataType='string' [allowEditing]="false"></dxi-column>
        <dxi-column caption='County' dataField='ca_region' dataType='string' [allowEditing]="false"></dxi-column>
        <dxi-column caption='City' dataField='ca_city' dataType='string' [allowEditing]="false"></dxi-column>
        <dxi-column caption='Status' dataField='ol_statusId' [allowEditing]='false'>
          <dxo-lookup [dataSource]='dsOrderStatusDesc' valueExpr='id' displayExpr='name'></dxo-lookup>
        </dxi-column>
        <dxi-column caption='Scheduled Date' dataField='ol_scheduledDate' dataType='datetime'
          [calculateDisplayValue]='ds.getDateTime' [allowEditing]="false"></dxi-column>
        <dxi-column caption='Estimated Unloaded' dataField='ol_estimatedUnload' dataType='string'
          [allowEditing]="false"></dxi-column>
        <!-- <dxi-column caption='Depot' dataField='d_name' dataType='string'></dxi-column> -->
        <dxi-column caption='Product' dataField='p_name' dataType='string' [allowEditing]="false"></dxi-column>
        <dxi-column caption='Product code' dataField='p_code' dataType='string' [allowEditing]="false"></dxi-column>
        <dxi-column caption='Ordered Quantity L15' dataField='ol_quantity' dataType='number' minWidth='220'
          [allowHeaderFiltering]='false' [allowEditing]="false"></dxi-column>
        <dxi-column caption='Loaded Quantity L15' dataField='ol_loadedQuantity' dataType='number'
          [allowHeaderFiltering]='false' [allowEditing]="true"></dxi-column>
        <dxi-column caption='Delivered Quantity L15' dataField='ol_deliveredQuantity' dataType='number'
          [allowHeaderFiltering]='false' [allowEditing]="true"></dxi-column>
        <dxi-column caption='Delivery Date' dataField='ol_deliveryDate' dataType='datetime'
          [calculateDisplayValue]='ds.getDateTime' [allowEditing]="false"></dxi-column>
        <dxi-column caption='Estimated Km' dataField='ol_estimatedKm' dataType='number' [allowHeaderFiltering]='false'
          [allowEditing]="false"></dxi-column>
        <dxi-column caption='Address' dataField='ca_description' dataType='string' [allowHeaderFiltering]='false'
          [allowEditing]="false"></dxi-column>
        <dxi-column caption='Comments' dataField='comments' dataType='string' [allowHeaderFiltering]='false'
          [allowEditing]="false"></dxi-column>
      </dx-data-grid>
    </dxi-item>
  </dx-tab-panel>
</div>
